=== debian/changelog ===
modsecurity (3.0.15-1~pre1+0~20250225~bpo12+a555e5a) bookworm-backports; urgency=medium

  * New upstream release

 -- Ervin Hegedüs <airween@digitalwave.hu>  Tue, 25 Feb 2025 16:18:02 +0100

modsecurity (3.0.14-1~pre1+0~20240904~bpo12+580fe19) bookworm-backports; urgency=medium

  * New upstream release

 -- Ervin Hegedüs <airween@digitalwave.hu>  Wed, 04 Sep 2024 15:07:10 +0200

modsecurity (3.0.13-1~pre1+0~20240130~bpo12+5f44383) bookworm-backports; urgency=medium

  * New upstream release

 -- Ervin Hegedus <airween@digitalwave.hu>  Tue, 30 Jan 2024 18:44:05 +0100

modsecurity (3.0.12-1~pre1+0~20231207~bpo12+bbde9381) bookworm-backports; urgency=medium

  * New upstream release
  * Remove ftbfs patch, upstream already applied

 -- Ervin Hegedüs <airween@digitalwave.hu>  Thu, 07 Dec 2023 15:32:19 +0100

modsecurity (3.0.11-1~pre1+0~20230726~bpo12+ccc2d9b5) bookworm-backports; urgency=medium

  * New upstream release

 -- Ervin Hegedüs <airween@digitalwave.hu>  Wed, 26 Jul 2023 21:58:20 +0200

modsecurity (3.0.10-1~pre1+0~20230609~bpo12+205dac0e) bookworm-backports; urgency=medium

  * New upstream
  * Bookworm port

 -- Ervin Hegedüs <airween@digitalwave.hu>  Fri, 09 Jun 2023 10:34:04 +0200
